<?php

namespace Drupal\openai_batch;

use Drupal\openai_batch\Entity\OpenAiBatchRequest;

/**
 * Interface for openai_batch_processor plugins.
 */
interface OpenAiBatchProcessorInterface {

  /**
   * Returns the translated plugin label.
   */
  public function label(): string;

  /**
   * Drupal Batch API operation callback, to process a single item from OpenAI's
   * Batch response.
   *
   * @param string $entity_type_id
   *  The entity type ID.
   * @param string $entity_id
   *  The entity ID.
   * @param string $result_string
   *  The result string from OpenAI's Batch response.
   * @param $context
   *
   * @return void
   */
  public function processResultItemOperation(OpenAiBatchRequest $openai_batch_request, string $entity_type_id, string $entity_id, string $result_string, &$context): void;

}
